function [vector] = contorn(imatge,segmentacio)
 
se2 = strel('disk',4);
%erode
e1=imerode(segmentacio,se2);
e2=imerode(e1,se2);
e3=imerode(e2,se2);
e4=imerode(e3,se2);
e5=imerode(e4,se2);
contorn_e=segmentacio-e5;
%dilate
d1=imdilate(segmentacio,se2);
d2=imdilate(d1,se2);
d3=imdilate(d2,se2);
d4=imdilate(d3,se2);
d5=imdilate(d4,se2);
contorn_d=d5-segmentacio;
%contorn total
contorn_total=contorn_e+contorn_d;

%interior del contorn
 interior=(d5-contorn_total);
 interior=imatge(interior~=0);
 %exterior del contorn
 exterior=imatge(d5==0);
 mitjana_int=mean(interior);
 desviacio_int=std(double(interior));
 vector1=[];vector2=[];
 
 %calculem mitjana i desviaci de l'erode1 i del dilate1
 mitjana_erode1=mean(imatge((segmentacio-e1)~=0));
 desviacio_erode1=std(double(imatge((segmentacio-e1)~=0)));
 mitjana_dilate1=mean(imatge((d1-segmentacio)~=0));
 desviacio_dilate1=std(double(imatge((d1-segmentacio)~=0)));

  %calculem mitjana i desviaci de l'erode2 i del dilate2
  mitjana_erode2=mean(imatge((segmentacio-e2)~=0));
 desviacio_erode2=std(double(imatge((segmentacio-e2)~=0)));
   mitjana_dilate2=mean(imatge((d2-segmentacio)~=0));
 desviacio_dilate2=std(double(imatge((d2-segmentacio)~=0)));

  %calculem mitjana i desviaci de l'erode3 i del dilate3
 mitjana_erode3=mean(imatge((segmentacio-e3)~=0));
 desviacio_erode3=std(double(imatge((segmentacio-e3)~=0)));
   mitjana_dilate3=mean(imatge((d3-segmentacio)~=0));
 desviacio_dilate3=std(double(imatge((d3-segmentacio)~=0)));
 
  %calculem mitjana i desviaci de l'erode4 i del dilate4
  mitjana_erode4=mean(imatge((segmentacio-e4)~=0));
 desviacio_erode4=std(double(imatge((segmentacio-e4)~=0)));
   mitjana_dilate4=mean(imatge((d4-segmentacio)~=0));
 desviacio_dilate4=std(double(imatge((d4-segmentacio)~=0)));
  
  %calculem mitjana i desviaci de l'erode5 i del dilate
  mitjana_erode5=mean(imatge((segmentacio-e5)~=0));
 desviacio_erode5=std(double(imatge((segmentacio-e5)~=0)));
  mitjana_dilate5=mean(imatge((d5-segmentacio)~=0));
 desviacio_dilate5=std(double(imatge((d5-segmentacio)~=0)));

%normalitzem i les colloquem al vector
 vector1=[(mitjana_erode5/mitjana_int),(mitjana_erode4/mitjana_int),(mitjana_erode3/mitjana_int),(mitjana_erode2/mitjana_int),(mitjana_erode1/mitjana_int)];

 vector1=[vector1,[(mitjana_dilate1/mitjana_int),(mitjana_dilate2/mitjana_int),(mitjana_dilate3/mitjana_int),(mitjana_dilate4/mitjana_int),(mitjana_dilate5/mitjana_int)]];

 vector2=[(desviacio_erode5/desviacio_int),(desviacio_erode4/desviacio_int),(desviacio_erode3/desviacio_int),(desviacio_erode2/desviacio_int),(desviacio_erode1/desviacio_int)];

 vector2=[vector2,[(desviacio_dilate1/desviacio_int),(desviacio_dilate2/desviacio_int),(desviacio_dilate3/desviacio_int),(desviacio_dilate4/desviacio_int),(desviacio_dilate5/desviacio_int)]];

%5 intensity/contrast
%normalitzem els histogrames
histint = imhist(interior);
histint = histint/sum(histint);
histext = imhist(exterior);
histext = histext/sum(histext);
%contrast1 
numerador=(mean(interior)-mean(exterior))^2;
denominador=var(double(interior))+var(double(exterior));
contrast1= double(numerador)/denominador;
% %contrast2
contrast2=sum(abs(histint-histext));
% %contrast 3

tmp = find(histint~=0 & histext~=0);
contrast3=sum((histint(tmp)-histext(tmp)).*(log(histint(tmp)./histext(tmp))));
% % %contrast 4
if isempty(tmp)
	contrast4 = 0;
else
	contrast4=-log(sum((histint(tmp).*histext(tmp)).^(-1/2)));
end
% %contrast 5
contrast5=sqrt(sum((histint-histext).^2));
%isodense

a=imhist(interior);
b=imhist(exterior);
x=find(cumsum(a)<0.1*sum(a),1,'last');
y=find(cumsum(b)<0.9*sum(b),1,'last');
%isodense1
isodense1=sum(histext(1:x));
% %isodense2
isodense2=1-sum(histint(1:y));


%vector de caracteristiques de contrast i densitat
contrast=[contrast1,contrast2,contrast3,contrast4,contrast5,isodense1,isodense2];

%vector de caracterstiques de contorn
vector=[vector1,vector2,contrast];

