function estad = coocStatistics(I,orientacio);

greylevels = 64;

%coocurrence matrix
gclm2 = graycomatrix(I,'Of',orientacio,'NumLevels',greylevels);

glcm2(1,:)=0;%posem a 0 tota la primera fila, ja que no ens interessa l'exterior de la massa
glcm2(:,1)=0;%posem a 0 tota la primera columna, ja que no ens interessa l'exterior de la massa
%defined statistics
stats = graycoprops(gclm2,{'Contrast', 'Correlation', 'Energy', 'Homogeneity'});

%other statistics
probs = gclm2./sum(sum(gclm2));
entrop(1:greylevels, 1:greylevels) = 0;
for i=1:greylevels
        for j=1:greylevels
                if (probs(i,j) ~= 0)
                        entrop(i,j) = probs(i,j)*log2(probs(i,j));
                end
        end
end
entropia = sum(sum(-entrop));

% px+y(k)(i+j=k)
pxy(1:(2*greylevels-1)) = 0;
for i=0:greylevels-1
        for j=0:greylevels-1
                pxy(i+j+1) = pxy(i+j+1)+ probs(i+1,j+1);
        end
end
        
% Calcul estadistic sum average
sum_average = 0;
for k=1:2*greylevels-1
        sum_average = sum_average +(k-1)*pxy(k);
end

%Calcul del estadistic sum sum_entropy
sum_entropy = 0;
for k=1:2*greylevels-1
        if pxy(k)~=0
                sum_entropy = sum_entropy+pxy(k)*log2(pxy(k));
        end
end
sum_entropy=-sum_entropy;

% Calcul del estadistic sum variance
sum_variance = 0;
for k=1:2*greylevels-1
        sum_variance = sum_variance+(k-1-sum_average)^2*pxy(k);
end

% px-y(k)|i-j|=k 
pxy2(1:greylevels) = 0;
for i=0:greylevels-1
        for j=0:greylevels-1
                pxy2(abs(i-j)+1) = pxy2(abs(i-j)+1)+ probs(i+1,j+1);
        end
end

% Calcul estadistic difference average 
diff_average = 0;
for k=1:greylevels
        diff_average = diff_average +(k-1)*pxy2(k);
end

% Calcul estadistic differencie entropy
diff_entropy = 0;
for k=1:greylevels
        if pxy2(k) ~= 0
                diff_entropy = diff_entropy + pxy2(k)*log2(pxy2(k));
        end
end
diff_entropy = -diff_entropy ;

% Calcul estadistic differencie variance
diff_variance = 0;
for k=1:greylevels
        if pxy2(k) ~= 0
                diff_variance = diff_variance+(k-1-diff_average)^2*pxy2(k);
        end
end

estad(1) = stats.Contrast;
estad(2) = stats.Energy;
estad(3) = entropia;
estad(4) = stats.Homogeneity;
estad(5) = stats.Correlation;
estad(6) = sum_average;
estad(7) = sum_entropy;
estad(8) = sum_variance;
estad(9) = diff_average;
estad(10) = diff_entropy;
estad(11) = diff_variance;

