function momentslist = Hu(region)
%calcula els 7 moments de hu
    momentslist(1:7) = 0;

    leafImage = double(region);
    % process / do the feature extraction using Hu imvariant moment
    [xSize, ySize] = size(leafImage);

    m00 = 0;
    m10 = 0;
    m01 = 0;

    mu00 = 0;
    mu20 = 0;
    mu11 = 0;
    mu02 = 0;
    mu30 = 0;
    mu21 = 0;
    mu12 = 0;
    mu03 = 0;

    eta20 = 0;
    eta11 = 0;
    eta02 = 0;
    eta30 = 0;
    eta21 = 0;
    eta12 = 0;
    eta03 = 0;

    xCentreOfMass = 0;
    yCentreOfMass = 0;

    gamma = 0;  % gamma = ((p + q) / 2) + 1

    for x=1:xSize
        for y=1:ySize
            i = leafImage(x, y);
            m00 = m00 + i;
            m10 = m10 + (i * x);
            m01 = m01 + (i * y);
        end
    end

    xCentreOfMass = m10 / m00;
    yCentreOfMass = m01 / m00;

    for x = 1:xSize
        for y = 1:ySize
            i = leafImage(x, y);
            mu00 = mu00 + i;
            mu20 = mu20 + (i * ((x - xCentreOfMass) ^ 2));
            mu11 = mu11 + (i * ((x - xCentreOfMass)) * (y - yCentreOfMass));
            mu02 = mu02 + (i * ((y - yCentreOfMass) ^ 2));
            mu30 = mu30 + (i * ((x - xCentreOfMass) ^ 3));
            mu21 = mu21 + (i * ((x - xCentreOfMass) ^ 2) * (y - yCentreOfMass));
            mu12 = mu12 + (i * ((x - xCentreOfMass)) * (y - yCentreOfMass) ^ 2);
            mu03 = mu03 + (i * ((y - yCentreOfMass) ^ 3));
        end
    end

    tmp1 = mu00 ^ 2;
    tmp2 = mu00 ^ 2.5;
    eta20 = mu20 / tmp1;
    eta11 = mu11 / tmp1;    % gamma = ((p + q) / 2) + 1
    eta02 = mu02 / tmp1;
    eta30 = mu30 / tmp2;
    eta21 = mu21 / tmp2;
    eta12 = mu12 / tmp2;
    eta03 = mu03 / tmp2;

    M1 = eta20 + eta02;
    M2 = ((eta20 - eta02) ^ 2) + (4 * (eta11 ^ 2));
    M3 = ((eta30 - (3 * eta12)) ^ 2) + (((3 * eta21) - eta03) ^ 2);
    M4 = ((eta30 + eta12) ^ 2) + ((eta21 + eta03) ^ 2);
    M5 = ((eta30 - (3 * eta12)) * (eta30 + eta12) * (((eta30 + eta12) ^ 2) - (3 * ((eta21 + eta03) ^ 2)))) + (((3 * eta21) - eta03) * (eta21 + eta03) * ((3 * ((eta30 + eta12) ^ 2)) - ((eta21 + eta03) ^ 2)));
    M6 = (eta20 - eta02) * (((eta30 + eta12) ^ 2) - ((eta21 + eta03) ^ 2) + (4 * eta11 * (eta30 + eta12) * (eta21 + eta03)));
    M7 = ((((3 * eta21) - eta03) * (eta30 + eta12) * (((eta30 + eta12) ^ 2) - (3 * (eta21 + eta03))))) + ( (3 * eta12 - eta30) * (eta21 + eta03) * ( (3 * ((eta12 + eta30) ^ 2)) - ((eta21 + eta03) ^ 2)));


    momentslist(1:7) = [M1, M2, M3, M4, M5, M6, M7];
